import 'package:amazing_button/amazing_animation.dart';
import 'package:amazing_button/enums/animationType.dart';
import 'package:flutter/material.dart';

class AmazingAnimationContainer extends StatefulWidget {
  final Widget child;
  final AmazingAnimation amazingAnimation;
  AmazingAnimationContainer({Key key, 
    @required this.child, 
    @required this.amazingAnimation
  }) : super(key: key);
  @override
  _AmazingAnimationContainerState createState() => _AmazingAnimationContainerState();
}

class _AmazingAnimationContainerState extends State<AmazingAnimationContainer> with SingleTickerProviderStateMixin{
  Animation<double> animation;
  AnimationController controller;
  @override
  void initState() {
    super.initState();
    controller = AnimationController(
      duration: widget.amazingAnimation.duration, 
      vsync: this,
    );
    if(widget.amazingAnimation == null){}
    if(widget.amazingAnimation.animationType == AnimationType.bounse){
      animation = Tween<double>(
        begin: widget.amazingAnimation.begin,
        end: widget.amazingAnimation.end
      ).animate(controller)
      ..addListener((){
        setState(() {
        });
      })
      ..addStatusListener((listener){
        if(listener == AnimationStatus.completed){
          controller.reverse();
        }else if(listener == AnimationStatus.dismissed){
          controller.forward();
        }
      });
    }
    controller.forward();
  }
  @override
  Widget build(BuildContext context) {
    if(widget.amazingAnimation == null){
      return Container(
        child: widget.child,
      );
    }else if(widget.amazingAnimation.animationType == AnimationType.bounse){
      return Container(
        child: Transform.scale(
          scale: animation.value,
          child: widget.child,
        ),
      );
    }else{
      return Container(
        child: widget.child,
      );
    }
    
  }
}