library amazing_button;

import 'package:amazing_button/amazing_animation.dart';
import 'package:amazing_button/amazing_animation_container.dart';
import 'package:amazing_button/enums/buttonType.dart';
import 'package:flutter/material.dart';

class AmazingButton extends StatefulWidget {
  ///display text on button
  final String text;
  //font size of text on button
  final double fontSize;
  //font color on button
  final Color color;
  //elevation of button
  final double elevation;
  //backgroun color of button
  final Color backgroundColor;
  //button border radius
  final BorderRadius borderRadius;
  //button border side color
  final Color borderSideColor;
  //padding in button
  final EdgeInsets padding;
  // on presed function
  //and it required
  final Function onPressed;
  //function for long press
  final Function onLongPress;
  //button width
  final double width;
  //button height
  final double height;
  //type of the button
  final ButtonType type; 
  //type od the animation
  final AmazingAnimation animation;
  // icon In button
  final IconData icon;  
  AmazingButton({
    Key key, 
    this.text, 
    this.fontSize, 
    this.elevation, 
    @required this.onPressed, 
    this.onLongPress, 
    this.color, 
    this.backgroundColor,
    this.borderRadius,
    this.borderSideColor,
    this.padding, 
    this.width, 
    this.height, 
    this.type, 
    this.icon,
    this.animation,
  }) : super(key: key);
  /*
  this constructor for secondery button
  */
  AmazingButton.secondery({
    Key key, 
    this.text, 
    this.fontSize, 
    this.elevation, 
    @required this.onPressed, 
    this.onLongPress, 
    this.color, 
    this.backgroundColor =const Color.fromRGBO(108, 117, 126, 1),
    this.borderRadius,
    this.borderSideColor =const Color.fromRGBO(108, 117, 126, 1),
    this.padding, 
    this.width, 
    this.height,
    this.type,
    this.icon,
    this.animation,
  });
  /*
    this constructor for success button
  */
  AmazingButton.success({
    Key key, 
    this.text, 
    this.fontSize, 
    this.elevation, 
    @required this.onPressed, 
    this.onLongPress, 
    this.color, 
    this.backgroundColor =const Color.fromRGBO(40, 168, 68, 1),
    this.borderRadius,
    this.borderSideColor =const Color.fromRGBO(40, 168, 68, 1),
    this.padding, 
    this.width, 
    this.height,
    this.type,
    this.icon,
    this.animation,
  });
  /*
    this constructor for danger button
  */
  AmazingButton.danger({
    Key key, 
    this.text, 
    this.fontSize, 
    this.elevation, 
    @required this.onPressed, 
    this.onLongPress, 
    this.color, 
    this.backgroundColor =const Color.fromRGBO(220, 53, 70, 1),
    this.borderRadius,
    this.borderSideColor =const Color.fromRGBO(220, 53, 70, 1),
    this.padding, 
    this.width, 
    this.height,
    this.type,
    this.icon,
    this.animation,
  });
  /*
    this constructor for warning button
  */
  AmazingButton.warning({
    Key key, 
    this.text, 
    this.fontSize, 
    this.elevation, 
    @required this.onPressed, 
    this.onLongPress, 
    this.color =const Color.fromRGBO(0, 0, 0, 1), 
    this.backgroundColor =const Color.fromRGBO(254, 193, 7, 1),
    this.borderRadius,
    this.borderSideColor =const Color.fromRGBO(254, 193, 7, 1),
    this.padding, 
    this.width, 
    this.height,
    this.type,
    this.icon,
    this.animation,
  });
  /*
    this constructor for info button
  */
  AmazingButton.info({
    Key key, 
    this.text, 
    this.fontSize, 
    this.elevation, 
    @required this.onPressed, 
    this.onLongPress, 
    this.color =const Color.fromRGBO(0, 0, 0, 1), 
    this.backgroundColor =const Color.fromRGBO(23, 162, 183, 1),
    this.borderRadius,
    this.borderSideColor =const Color.fromRGBO(23, 162, 183, 1),
    this.padding, 
    this.width, 
    this.height,
    this.type,
    this.icon,
    this.animation,
  });
  /*
    this constructor for light button
  */
  AmazingButton.light({
    Key key, 
    this.text, 
    this.fontSize, 
    this.elevation, 
    @required this.onPressed, 
    this.onLongPress, 
    this.color =const Color.fromRGBO(45, 45, 45, 1), 
    this.backgroundColor =const Color.fromRGBO(248, 248, 250, 1),
    this.borderRadius,
    this.borderSideColor =const Color.fromRGBO(248, 248, 250, 1),
    this.padding, 
    this.width, 
    this.height,
    this.type,
    this.icon,
    this.animation,
  });
  /*
    this constructor for dark button
  */
  AmazingButton.dark({
    Key key, 
    this.text, 
    this.fontSize, 
    this.elevation, 
    @required this.onPressed, 
    this.onLongPress, 
    this.color, 
    this.backgroundColor =const Color.fromRGBO(55, 55, 55, 1),
    this.borderRadius,
    this.borderSideColor =const Color.fromRGBO(55, 55, 55, 1),
    this.padding, 
    this.width, 
    this.height,
    this.type,
    this.icon,
    this.animation,
  });
  /*
    this constructor for link button
  */
  AmazingButton.link({
    Key key, 
    this.text, 
    this.fontSize, 
    this.elevation, 
    @required this.onPressed, 
    this.onLongPress, 
    this.color =const Color.fromRGBO(9, 124, 248, 1), 
    this.backgroundColor =const Color.fromRGBO(255, 255, 255, 1),
    this.borderRadius,
    this.borderSideColor =const Color.fromRGBO(255, 255, 255, 1),
    this.padding, 
    this.width, 
    this.height,
    this.type,
    this.icon,
    this.animation,
  });
  @override
  _AmazingButtonState createState() => _AmazingButtonState();
}


class _AmazingButtonState extends State<AmazingButton> {
  @override
  Widget build(BuildContext context) {
    return Container(
      child: AmazingAnimationContainer(
        amazingAnimation: widget.animation,
        child: _button(),
      ),
    );
  }
  Widget _button(){
    if(widget.type == null){
      return new Container(
        width: widget.width,
        height: widget.height,
        child: RaisedButton(
          child: Text(widget.text==null?"OK":widget.text,
            style: TextStyle(
              fontSize: widget.fontSize==null?20:widget.fontSize,
              color: widget.color==null?Colors.white:widget.color,
              ),
            ),
          color: widget.backgroundColor==null?Color.fromRGBO(0, 122, 255, 1):widget.backgroundColor,
          autofocus: true,
          padding: widget.padding==null?EdgeInsets.all(10):widget.padding,
          shape: RoundedRectangleBorder(
            borderRadius: widget.borderRadius==null?BorderRadius.all(Radius.circular(20)):widget.borderRadius,
            side: BorderSide(
              color: widget.borderSideColor==null?Color.fromRGBO(0, 122, 255, 1):widget.borderSideColor,
            )
          ),
          elevation: widget.elevation,
          onPressed: widget.onPressed,
          onLongPress: widget.onLongPress,
        )
      );
    }else if(widget.type == ButtonType.outline){
      return Container(
        width: widget.width,
        height: widget.height,
        child: RaisedButton(
          child: Text(widget.text==null?"OK":widget.text,
            style: TextStyle(
              fontSize: widget.fontSize==null?20:widget.fontSize,
              color: widget.borderSideColor==null?Color.fromRGBO(0, 122, 255, 1):widget.borderSideColor,
              ),
            ),
          color: widget.backgroundColor==null?
            Colors.white : widget.backgroundColor == widget.borderSideColor?
              Colors.white : widget.backgroundColor,
          autofocus: true,
          padding: widget.padding==null?EdgeInsets.all(10):widget.padding,
          shape: RoundedRectangleBorder(
            borderRadius: widget.borderRadius==null?BorderRadius.all(Radius.circular(20)):widget.borderRadius,
            side: BorderSide(
              color: widget.borderSideColor==null?Color.fromRGBO(0, 122, 255, 1):widget.borderSideColor,
            )
          ),
          elevation: widget.elevation,
          onPressed: widget.onPressed,
          onLongPress: widget.onLongPress,
        )
      );
    }
    else if(widget.type == ButtonType.round){
      double buttonWidth = widget.width == null?65:widget.width;
      return Container(
        width: buttonWidth,
        height: buttonWidth,
        child: RaisedButton(
          child: Icon(
            widget.icon==null?Icons.add:widget.icon,
            size: buttonWidth - (buttonWidth<20?buttonWidth:buttonWidth<100?20:40),
            color: widget.color==null?Colors.white:widget.color,
          ),
          color: widget.backgroundColor==null?Color.fromRGBO(0, 122, 255, 1):widget.backgroundColor,
          autofocus: true,
          padding: widget.padding==null?EdgeInsets.all(10):widget.padding,
          shape: RoundedRectangleBorder(
            borderRadius: widget.borderRadius==null?
              BorderRadius.all(Radius.circular(buttonWidth)):widget.borderRadius,
            side: BorderSide(
              color: widget.borderSideColor==null?Color.fromRGBO(0, 122, 255, 1):widget.borderSideColor,
            )
          ),
          elevation: widget.elevation,
          onPressed: widget.onPressed,
          onLongPress: widget.onLongPress,
        )
      );
    }else if(widget.type == ButtonType.roundoutline){
      double buttonWidth = widget.width == null?65:widget.width;
      return Container(
        width: buttonWidth,
        height: buttonWidth,
        child: RaisedButton(
          child: Icon(
            widget.icon==null?Icons.add:widget.icon,
            size: buttonWidth - (buttonWidth<20?buttonWidth:buttonWidth<100?20:40),
            color: widget.borderSideColor==null?Color.fromRGBO(0, 122, 255, 1):widget.borderSideColor,
          ),
          color: widget.backgroundColor==null?
            Colors.white : widget.backgroundColor == widget.borderSideColor?
              Colors.white : widget.backgroundColor,
          autofocus: true,
          padding: widget.padding==null?EdgeInsets.all(10):widget.padding,
          shape: RoundedRectangleBorder(
            borderRadius: widget.borderRadius==null?
              BorderRadius.all(Radius.circular(buttonWidth)):widget.borderRadius,
            side: BorderSide(
              color: widget.borderSideColor==null?Color.fromRGBO(0, 122, 255, 1):widget.borderSideColor,
            )
          ),
          elevation: widget.elevation,
          onPressed: widget.onPressed,
          onLongPress: widget.onLongPress,
        )
      );
    }else if(widget.type == ButtonType.textIcon){
      return new Container(
        width: widget.width,
        height: widget.height,
        child: RaisedButton(
          child: Row(
            mainAxisAlignment: MainAxisAlignment.center,
            mainAxisSize: MainAxisSize.min,
            children: <Widget>[
              Text(widget.text==null?"OK":widget.text,
                style: TextStyle(
                  fontSize: widget.fontSize==null?20:widget.fontSize,
                  color: widget.color==null?Colors.white:widget.color,
                ),
              ),
              Container(
                margin: EdgeInsets.only(left: 20,right: 10),
                child: Icon(
                  widget.icon==null?Icons.add:widget.icon,
                  size: widget.fontSize==null?20:widget.fontSize,
                  color: widget.color==null?Colors.white:widget.color,
                ),
              ),
            ],
          ),
          color: widget.backgroundColor==null?Color.fromRGBO(0, 122, 255, 1):widget.backgroundColor,
          autofocus: true,
          padding: widget.padding==null?EdgeInsets.all(10):widget.padding,
          shape: RoundedRectangleBorder(
            borderRadius: widget.borderRadius==null?BorderRadius.all(Radius.circular(10)):widget.borderRadius,
            side: BorderSide(
              color: widget.borderSideColor==null?Color.fromRGBO(0, 122, 255, 1):widget.borderSideColor,
            )
          ),
          elevation: widget.elevation,
          onPressed: widget.onPressed,
          onLongPress: widget.onLongPress,
        )
      );
    }else if(widget.type == ButtonType.iconText){
      return new Container(
        width: widget.width,
        height: widget.height,
        child: RaisedButton(
          child: Row(
            mainAxisAlignment: MainAxisAlignment.center,
            mainAxisSize: MainAxisSize.min,
            children: <Widget>[
              Container(
                margin: EdgeInsets.only(right: 10),
                child: Icon(
                  widget.icon==null?Icons.add:widget.icon,
                  size: widget.fontSize==null?20:widget.fontSize,
                  color: widget.color==null?Colors.white:widget.color,
                ),
              ),
              Text(widget.text==null?"OK":widget.text,
                style: TextStyle(
                  fontSize: widget.fontSize==null?20:widget.fontSize,
                  color: widget.color==null?Colors.white:widget.color,
                ),
              ),
            ],
          ),
          color: widget.backgroundColor==null?Color.fromRGBO(0, 122, 255, 1):widget.backgroundColor,
          autofocus: true,
          padding: widget.padding==null?EdgeInsets.all(10):widget.padding,
          shape: RoundedRectangleBorder(
            borderRadius: widget.borderRadius==null?BorderRadius.all(Radius.circular(10)):widget.borderRadius,
            side: BorderSide(
              color: widget.borderSideColor==null?Color.fromRGBO(0, 122, 255, 1):widget.borderSideColor,
            )
          ),
          elevation: widget.elevation,
          onPressed: widget.onPressed,
          onLongPress: widget.onLongPress,
        )
      );
    }
    else{
      return Container();
    }
  }
}